<?php
include("markdown.php");
class h_controller extends frontend_controller{
// da39a3ee5e6b4b0d3255bfef95601890afd80709 - is magical value (sha-1 of blank string)
  function index(){
	rpd::redirect("h/g/".rpd::config("modules.hvala.front_hash"));
  }
  
  function k($id="da39a3ee5e6b4b0d3255bfef95601890afd80709"){
      $this->db->select("*")->from("hvala_posts")->where('hash',$id)->get();
      $art=$this->db->row_array();
      
      $g=new datagrid_library();
      $g->db->select("*")->from('hvala_posts')->where('prevhash',$id)->orderby('date','ASC');
      $g->column('{fromm} <a href="'.$this->url('h/k').'/{hash}">{subject}</a><br>{text}','')->callback('myrkdown_comment');
      $g->build();
      
      $prevlink="";
      if (!empty($art["previous"])){
        $prevlink=$this->anchor("h/k/".$art['prevhash'],rpd::lang("hvala.precursor"))."<hr>";
      }
      
      $replylink="";
      if ($this->auth->logged()){
        $replylink=$this->anchor("hvala/post/".$id,rpd::lang("hvala.reply_btn"));
      }
      
      $this->title=$art['subject'];
      $data['content']=$prevlink.rpd::lang("hvala.posted_by")." ".$art['fromm']."<br>".Markdown($art['text']).$g->output.$replylink;
      
      if ($id=="da39a3ee5e6b4b0d3255bfef95601890afd80709"){
        $this->title=rpd::lang("hvala.root_category");
        $data["content"]="&nbsp;".$g->output;
      }
      
      echo $this->view('page',$data);
  }
  
  function g($id="da39a3ee5e6b4b0d3255bfef95601890afd80709"){
      $this->title=rpd::lang("hvala.root_category");
      
      $g=new datagrid_library();
      $g->db->select("*")->from('hvala_posts')->where('prevhash',$id)->orderby('date','DESC');
      $g->column('{fromm} <a href="'.$this->url('h/p').'/{id}">{subject}</a><br>{text}','')->callback('myrkdown_grouppost');
      $g->build();     
      
      if ($id!="da39a3ee5e6b4b0d3255bfef95601890afd80709"){
        $this->db->select("*")->from("hvala_posts")->where("hash",$id)->get();
        $topic=$this->db->row_array();
        $this->title=$topic["subject"];
        $data['content']=Markdown($topic['text']).$g->output;
      }else{
        $data['content']=$g->output;
      }
      echo $this->view('page',$data);
  }
  
  
  function menu(){
    if ($this->auth->logged()){
      return "<li>".$this->anchor("hvala/post/da39a3ee5e6b4b0d3255bfef95601890afd80709",rpd::lang("hvala.new_post"))."</li><li>".$this->anchor("log/out",rpd::lang("hvala.logout"))."</li>";
    }else{
      return "<li>".$this->anchor("log/in/next/h",rpd::lang("hvala.login"))."</li>";
    }
  }
  
  function api(){
    $data="API is live!";
    $status=200;
    
    if (isset($_GET["get"])){
    switch ($_GET["get"]){
      case "ping":
        $data="pong";
        break;
      case "message":
        if (isset($_GET["key"])){
          $this->db->select("*")->from("hvala_posts")->where("hash",$_GET["key"])->get();
          $post=$this->db->row_array();
          if ($post){
            $m=new manuscripts_helper();
            $m->precursor=$post['prevhash'];
            $m->from=$post['fromm'];
            $m->subject=$post['subject'];
            $m->date=$post['date'];
            $m->text=$post['text'];
            $data=$m->raw();
          }else{
            $status=404;
            $data="Not found!";
          }
        }else{
          $status=404;
          $data="Specify key!";
        }
        break;
      case "newsindex":
        $this->db->select("*")->from("hvala_posts")->where("date<","date('now -2day')",true)->orderby('date','DESC')->get();
        $data="";
        while ($r=$this->db->row_array()){
          $data.=$r['hash'].";".$r["fromm"].";".$r['subject'].";".$r["date"]."\n";
        }
        break;
    }
    }
    
    if ($status==200){
      header("HTTP/1.0 404 Not Found");   
    }elseif($status==403){
      header("HTTP/1.0 403 Forbiddden");       
    }else{
      header("HTTP/1.0 404 Not Found");
    }header('Content-type: text/plain');
    echo $data;
  }
}

function myrkdown_comment($a){
    return $a['fromm']." : ".rpd::anchor('h/k/'.$a['hash'],$a['subject'])."<br>".Markdown($a['text']);
}

function myrkdown_grouppost($a){
    return $a['fromm']." : ".rpd::anchor('h/k/'.$a['hash'],$a['subject'])."<br>".Markdown($a['text'])."<small>".$a['date']."</small>";
}

function myrkdown_blogpost($a){
    $replylink;
    if (rpd::$auth->logged()){
      $replylink=rpd::anchor("hvala/reply/".$a['id'],"odpovědět");
    }
    rpd::$db->select("count(subject) AS count")->from('hvala_posts')->where('previous',$a['id'])->get();
    $res=rpd::$db->row_array();
    $replies="";
    if (!empty($res["count"])){
      $replies=rpd::anchor("h/p/".$a["id"],$res["count"]." reakcí")."&nbsp;";
    }
    return rpd::anchor('h/p/'.$a['id'],$a['subject'])."<br>".Markdown($a['text']).$replies.$replylink;
}