<?php
class log_controller extends frontend_controller{

function __construct(){
  parent::__construct();
  $this->title="Přihlášení";
}

function index(){
  $data['content']="";
  echo $this->view("page",$data);
}

function in(){
  $to=$no=rpd_url_helper::uri_value("next");    
  if ($this->auth->logged())
		{
			rpd::redirect($to);
		} else {

			//form
			$form = new dataform_library();
			$form->field('input','user_','Uživatel')->rule('required');
			$form->field('password','pass_','Heslo')->rule('required');
			$form->submit('save','přihlásit');
			$form->build();

			if ($form->on('show') OR $form->on('error'))
			{
				$output = "Na prohlížení této záložky musíte být přihlášeni. ".$form->output;
			}

			if ($form->on('success'))
			{
				//is a valid user
				$valid_user = $this->auth->login($_POST["user_"], $_POST["pass_"]);
				rpd::redirect($to);
			}

			//$this->render($form->output);
			$data['content']=$output;
      echo $this->view('page',$data);
		}
}

public function out()
	{
		$this->auth->logout();
		rpd::redirect("");
	}

public function menu(){
  return "<li>".$this->anchor("log/in","přihlásit")."</li>".
  "<li>".$this->anchor("log/out","odhlásit")."</li>";
}

}
